#include <iostream>
#include <signal.h>
#include <boost/format.hpp>
#include "RT_Inference.h"

int main(int argc, char** argv)
{
  std::string enginef = "../../data/why.pb.uff";

  // ----------------- why
  int H = 5;
  int W = 5;
  int C = 3;
  std::vector<std::string> in_names;
  std::vector<std::string> out_names;
  std::vector<DimsCHW> in_shapes;
  in_names.push_back("Placeholder");
  in_shapes.push_back(DimsCHW(C, H, W));
  out_names.push_back("output");

  // ----------------- image. just constant 0.5
  float *p_image_rgb_chw = new float[H*W*C];
  for (int h = 0; h < H; ++h)
    for (int w = 0; w < W; ++w)
      for (int c = 0; c < C; ++c)
        p_image_rgb_chw[c*H*W+h*W+w] = 0.5;

  RT_Inference rt_inference;
  rt_inference.create_engine(enginef, in_names, out_names, in_shapes);
  rt_inference.execute_dummy(p_image_rgb_chw);
  return 1;
}

